/*!
  \file texture.h
  \brief Contains the texture class, that handles the reading of Images into Texutre-files.

  \todo free SDL-surface when deleting Material.
  \todo delete imgNameWithPath after use creation.
*/

#ifndef _TEXTURE_H
#define _TEXTURE_H

#include "glincl.h"

#include "debug.h"

#include <SDL_image.h>

//! A Class, that reads in Textures from different fileformats.
class Texture
{
 private:
  GLuint texture;   //!< The Texture-ID of opengl from this Texture.
  char* searchTextureInPaths(const char* texName) const;
  void swap(unsigned char &a, unsigned char &b);
 public:
  Texture(const char* imageName = NULL);
  ~Texture(void);

  /** \returns The textureID of this texture.  */
  inline GLuint getTexture(void) {return this->texture;} 
  GLuint loadTexToGL (SDL_Surface* surface);

  bool loadImage(const char* imageName);
};

#endif /* _TEXTURE_H */
